﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc {
  using HeuristicLab.Common;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public abstract class ErcOption<T> : ErcOptionConvertible<T, T> {
    protected ErcOption() : this(false, new IWeightedErcValueItem<T>[0]) { }

    protected ErcOption(bool isEnabled, params IWeightedErcValueItem<T>[] values)
        : base(x => x, isEnabled, values) { }

    [StorableConstructor]
    protected ErcOption(bool deserializing)
        : base(deserializing) {
    }

    protected ErcOption(ErcOptionConvertible<T, T> origin, Cloner cloner)
        : base(origin, cloner) {
    }
  }
}
