﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer {
  using Common;
  using Data;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class IntegerConstantErcValue : ConstantsWeightedErcValue<int, IntArray> {

    public IntegerConstantErcValue() : this(new int[0]) { }

    public IntegerConstantErcValue(params int[] constants) : base(new IntArray(constants)) { }

    [StorableConstructor]
    public IntegerConstantErcValue(bool deserializing) : base(deserializing) { }

    public IntegerConstantErcValue(IntegerConstantErcValue origin, Cloner cloner) : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new IntegerConstantErcValue(this, cloner);
    }
  }
}
