﻿using System.Linq;

namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.IntegerVector {
  using HeuristicLab.Common;
  using HeuristicLab.Data;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class IntegerVectorConstantsErcValue : VectorConstantsErcValue<int, IntArray> {
    public IntegerVectorConstantsErcValue() {
    }

    public IntegerVectorConstantsErcValue(params int[][] values)
      : this(true, values) {
    }

    public IntegerVectorConstantsErcValue(bool isEnabled, params int[][] values)
      : base(isEnabled, values.Select(v => new IntArray(v)).ToArray()) {
    }

    [StorableConstructor]
    protected IntegerVectorConstantsErcValue(bool deserializing)
      : base(deserializing) {
    }

    public IntegerVectorConstantsErcValue(IntegerVectorConstantsErcValue origin, Cloner cloner)
      : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new IntegerVectorConstantsErcValue(this, cloner);
    }
  }
}
